{
    "$graph": [
        {
            "label": "blastn_wnode",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.blastdb_dir)",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "blastn_wnode",
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache"
                    },
                    "id": "#blastn_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-best_hit_overhang"
                    },
                    "id": "#blastn_wnode.cwl/best_hit_overhang"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-best_hit_score_edge"
                    },
                    "id": "#blastn_wnode.cwl/best_hit_score_edge"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-blastdb",
                        "valueFrom": "$(inputs.blastdb_dir.path)/$(inputs.blastdb)"
                    },
                    "id": "#blastn_wnode.cwl/blastdb"
                },
                {
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "id": "#blastn_wnode.cwl/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-dust"
                    },
                    "id": "#blastn_wnode.cwl/dust"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.01,
                    "inputBinding": {
                        "prefix": "-evalue"
                    },
                    "id": "#blastn_wnode.cwl/evalue"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#blastn_wnode.cwl/input_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 250,
                    "inputBinding": {
                        "prefix": "-max_target_seqs"
                    },
                    "id": "#blastn_wnode.cwl/max_target_seqs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#blastn_wnode.cwl/output_dir"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-perc_identity"
                    },
                    "id": "#blastn_wnode.cwl/perc_identity"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "-soft_masking"
                    },
                    "id": "#blastn_wnode.cwl/soft_masking"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-swap-rows"
                    },
                    "id": "#blastn_wnode.cwl/swap_rows"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "blastn",
                    "inputBinding": {
                        "prefix": "-task"
                    },
                    "id": "#blastn_wnode.cwl/task"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 12,
                    "inputBinding": {
                        "prefix": "-word_size"
                    },
                    "id": "#blastn_wnode.cwl/word_size"
                }
            ],
            "id": "#blastn_wnode.cwl",
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.output_dir)"
                    },
                    "id": "#blastn_wnode.cwl/outdir"
                }
            ]
        },
        {
            "label": "gpx_make_outputs",
            "class": "CommandLineTool",
            "baseCommand": "gpx_make_outputs",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_make_outputs.cwl/input_path"
                },
                {
                    "doc": "this parameter is fixed for this command line workflow, because the output is defined as single file\n",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "-num-partitions"
                    },
                    "id": "#gpx_make_outputs.cwl/num_partitions"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_make_outputs.cwl/output"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#gpx_make_outputs.cwl/output_glob"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "*",
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_make_outputs.cwl/unzip"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_glob)"
                    },
                    "id": "#gpx_make_outputs.cwl/output_file"
                }
            ],
            "id": "#gpx_make_outputs.cwl"
        },
        {
            "label": "gpx_qsubmit",
            "doc": "This workflow is specialized for the case when there is an LDS2 input  LDS2 is a _reference_ object, the kind that CWL does not like we need to provide actual input: proteins which matches the name of ASN.1 object references in LDS2 Another limitation is that it can handle no more than two item arrays in blastdb_dir and asn_cache Workaround used so far: in:\n  proteins:\n    default:\n        class: File\n        path: '/dev/null'\n        basename: 'null'\n        contents: ''\n",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=0; var s=inputs.blastdb_dir.length-1; var as = cs; if(as >= s) {as = s }; return inputs.blastdb_dir[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.blastdb_dir.length-1; var as = cs; if(as >= s) {as = s }; return inputs.blastdb_dir[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=0; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entryname": "ids.mft",
                            "entry": "${var blob = '# ids.mft created for gpx_qsubmit from input ids Array of Files\\n';for (var i = 0; i < inputs.ids.length; i++) {blob += inputs.ids[i].path  + '\\n';}return blob;}"
                        }
                    ]
                }
            ],
            "baseCommand": "gpx_qsubmit",
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-NxM-threshold"
                    },
                    "id": "#gpx_qsubmit.cwl/NxM_threshold"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "subject",
                    "inputBinding": {
                        "prefix": "-affinity"
                    },
                    "id": "#gpx_qsubmit.cwl/affinity"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#gpx_qsubmit.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-batch-size"
                    },
                    "id": "#gpx_qsubmit.cwl/batch_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-db",
                        "valueFrom": "${ var blob = ''; for (var i = 0; i < inputs.blastdb_dir.length; i++) { blob += inputs.blastdb_dir[i].path + '/' + inputs.blastdb[i]; if(i != inputs.blastdb_dir.length-1) blob += ','; } return blob; }"
                    },
                    "id": "#gpx_qsubmit.cwl/blastdb"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "id": "#gpx_qsubmit.cwl/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#gpx_qsubmit.cwl/ids"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "ids.mft",
                    "inputBinding": {
                        "prefix": "-ids-manifest"
                    },
                    "id": "#gpx_qsubmit.cwl/ids_manifest"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#gpx_qsubmit.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-batch-length"
                    },
                    "id": "#gpx_qsubmit.cwl/max_batch_length"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "-nogenbank"
                    },
                    "id": "#gpx_qsubmit.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gpx_qsubmit.cwl/output_xml_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-overlap"
                    },
                    "id": "#gpx_qsubmit.cwl/overlap"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gpx_qsubmit.cwl/proteins"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-queries-gc-id-list"
                    },
                    "id": "#gpx_qsubmit.cwl/queries_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-subjects-gc-id-list"
                    },
                    "id": "#gpx_qsubmit.cwl/subjects_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-subseq-size"
                    },
                    "id": "#gpx_qsubmit.cwl/subseq_size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-xml-jobs"
                    },
                    "id": "#gpx_qsubmit.cwl/xml_jobs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_xml_jobs)"
                    },
                    "id": "#gpx_qsubmit.cwl/jobs"
                }
            ],
            "id": "#gpx_qsubmit.cwl"
        },
        {
            "label": "tt_blastn_wnode",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/affinity"
                },
                {
                    "type": "Directory",
                    "id": "#main/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/best_hit_overhang"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/best_hit_score_edge"
                },
                {
                    "type": "string",
                    "id": "#main/blastdb"
                },
                {
                    "type": "Directory",
                    "id": "#main/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/dust"
                },
                {
                    "type": "float",
                    "id": "#main/evalue"
                },
                {
                    "type": "File",
                    "id": "#main/ids_out"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/max_batch_length"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/max_target_seqs"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/perc_identity"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/soft_masking"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/task"
                },
                {
                    "type": "int",
                    "id": "#main/word_size"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/gpx_make_outputs/output_file",
                    "id": "#main/blast_align"
                }
            ],
            "steps": [
                {
                    "run": "#blastn_wnode.cwl",
                    "in": [
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/blastn_wnode/asn_cache"
                        },
                        {
                            "source": "#main/best_hit_overhang",
                            "id": "#main/blastn_wnode/best_hit_overhang"
                        },
                        {
                            "source": "#main/best_hit_score_edge",
                            "id": "#main/blastn_wnode/best_hit_score_edge"
                        },
                        {
                            "source": "#main/blastdb",
                            "id": "#main/blastn_wnode/blastdb"
                        },
                        {
                            "source": "#main/blastdb_dir",
                            "id": "#main/blastn_wnode/blastdb_dir"
                        },
                        {
                            "source": "#main/dust",
                            "id": "#main/blastn_wnode/dust"
                        },
                        {
                            "source": "#main/evalue",
                            "id": "#main/blastn_wnode/evalue"
                        },
                        {
                            "source": "#main/gpx_qsubmit/jobs",
                            "id": "#main/blastn_wnode/input_jobs"
                        },
                        {
                            "source": "#main/max_target_seqs",
                            "id": "#main/blastn_wnode/max_target_seqs"
                        },
                        {
                            "source": "#main/perc_identity",
                            "id": "#main/blastn_wnode/perc_identity"
                        },
                        {
                            "default": "true",
                            "id": "#main/blastn_wnode/soft_masking"
                        },
                        {
                            "default": false,
                            "id": "#main/blastn_wnode/swap_rows"
                        },
                        {
                            "default": "blastn",
                            "id": "#main/blastn_wnode/task"
                        },
                        {
                            "source": "#main/word_size",
                            "id": "#main/blastn_wnode/word_size"
                        }
                    ],
                    "out": [
                        "#main/blastn_wnode/outdir"
                    ],
                    "id": "#main/blastn_wnode"
                },
                {
                    "run": "#gpx_make_outputs.cwl",
                    "in": [
                        {
                            "source": "#main/blastn_wnode/outdir",
                            "id": "#main/gpx_make_outputs/input_path"
                        },
                        {
                            "default": 1,
                            "id": "#main/gpx_make_outputs/num_partitions"
                        },
                        {
                            "default": "blast.#.asn",
                            "id": "#main/gpx_make_outputs/output"
                        },
                        {
                            "default": "blast.*.asn",
                            "id": "#main/gpx_make_outputs/output_glob"
                        }
                    ],
                    "out": [
                        "#main/gpx_make_outputs/output_file"
                    ],
                    "id": "#main/gpx_make_outputs"
                },
                {
                    "run": "#gpx_qsubmit.cwl",
                    "in": [
                        {
                            "source": "#main/affinity",
                            "id": "#main/gpx_qsubmit/affinity"
                        },
                        {
                            "source": [
                                "#main/asn_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/gpx_qsubmit/asn_cache"
                        },
                        {
                            "source": [
                                "#main/blastdb"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/gpx_qsubmit/blastdb"
                        },
                        {
                            "source": [
                                "#main/blastdb_dir"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/gpx_qsubmit/blastdb_dir"
                        },
                        {
                            "source": [
                                "#main/ids_out"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/gpx_qsubmit/ids"
                        },
                        {
                            "source": "#main/max_batch_length",
                            "id": "#main/gpx_qsubmit/max_batch_length"
                        },
                        {
                            "default": true,
                            "id": "#main/gpx_qsubmit/nogenbank"
                        },
                        {
                            "default": {
                                "class": "File",
                                "path": "https://raw.githubusercontent.com/dev/null",
                                "basename": "null",
                                "contents": ""
                            },
                            "id": "#main/gpx_qsubmit/proteins"
                        }
                    ],
                    "out": [
                        "#main/gpx_qsubmit/jobs"
                    ],
                    "id": "#main/gpx_qsubmit"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
